Package: branchpointer
Type: Package
Title: Prediction of intronic splicing branchpoints
Version: 1.38.0
Date: 2025-07-22
Author: Beth Signal
Maintainer: Beth Signal <b.signal@garvan.org.au>
Description: Predicts branchpoint probability for sites in intronic branchpoint windows. Queries can be supplied as intronic regions; or to evaluate the effects of mutations, SNPs.
License: BSD_3_clause + file LICENSE
Depends: caret, R(>= 3.4)
Imports: plyr, kernlab, gbm, stringr, cowplot, ggplot2, biomaRt,
        Biostrings, parallel, utils, stats,
        BSgenome.Hsapiens.UCSC.hg38, rtracklayer, GenomicRanges,
        Seqinfo, IRanges, S4Vectors, data.table
Suggests: knitr, BiocStyle
RoxygenNote: 6.0.1
VignetteBuilder: knitr
biocViews: Software, GenomeAnnotation, GenomicVariation,
        MotifAnnotation
git_url: https://git.bioconductor.org/packages/branchpointer
git_branch: RELEASE_3_23
git_last_commit: 8b735ec
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 20:59:07 UTC; biocbuild

#' Makes a branchpointer formatted GRanges object from refsnp ids
#'
#' Searches Biomart for refsnp ids, and pulls genomic location and sequence identity information
#' Reformats alleles so each query has only one alternative allele
#' @param refSNP Vector of refsnp ids
#' @param mart.snp biomaRt mart object specifying the BioMart database and dataset to be used
#' @param exons GRanges containing exon co-ordinates.
#' Should be produced by gtfToExons()
#' @param maxDist maximum distance a SNP can be from an annotated 3' exon.
#' @param filter remove SNP queries prior to finding finding nearest exons?
#' @return formatted SNP query GRanges
#' @export
#' @import biomaRt
#' @import GenomicRanges
#' @importFrom stringr str_split
#' @importFrom S4Vectors Rle
#' @importFrom IRanges IRanges
#' @examples
#' smallExons <- system.file("extdata","gencode.v26.annotation.small.gtf",package = "branchpointer")
#' exons <- gtfToExons(smallExons)
#' 
#' mart.snp <- biomaRt::useMart("ENSEMBL_MART_SNP", dataset="hsapiens_snp", host="www.ensembl.org")
#' query <- makeBranchpointWindowForSNP("rs587776767", mart.snp, exons)
#' @author Beth Signal

makeBranchpointWindowForSNP <- function(refSNP, mart.snp,exons,maxDist=50, filter=TRUE){
  snpInfo <- biomaRt::getBM(attributes = c("refsnp_id",'refsnp_source', "chr_name",
                                   "chrom_start", "allele"),
                    filters = "snp_filter", values = refSNP, mart = mart.snp)

  #make sure each SNP has only 1 ref and 1 alternate allele
  multiAlleles <- which(nchar(snpInfo$allele) != 3)

  if (length(multiAlleles) > 0) {
    snpInfo.remade <- snpInfo[-multiAlleles,]
    snpInfo <- snpInfo[multiAlleles,]

    for (i in seq_along(snpInfo$refsnp_id)) {
      nts <- unlist(stringr::str_split(snpInfo$allele[i],"/"))
      ref <- nts[1]
      alt <- nts[-1]
      alleles <- paste0(ref,"/",alt)

      remade <- snpInfo[c(rep(i, length(alleles))),]
      remade$allele <- alleles
      snpInfo.remade <- rbind(snpInfo.remade, remade)
    }
    snpInfo <- snpInfo.remade
  }

  
  
  queryGRanges <- GRanges(seqnames=S4Vectors::Rle(paste0("chr",snpInfo$chr_name)),
                          ranges=IRanges::IRanges(start=snpInfo$chrom_start, width=1),
                          strand="*",
                          id=snpInfo$refsnp_id,
                          ref_allele=stringr::str_sub(snpInfo$allele,1,1),
                          alt_allele=stringr::str_sub(snpInfo$allele,3,3))

  #check for unstranded queries & replace with positive & negative
  unstranded <- which(as.logical(strand(queryGRanges) == "*"))
  if(length(unstranded)>0){
    queryGRanges.pos <- queryGRanges[unstranded]
    queryGRanges.pos$id <- 
      paste0(queryGRanges.pos$id, "_pos")
    strand(queryGRanges.pos) <- "+"
    
    queryGRanges.neg <- queryGRanges[unstranded]
    queryGRanges.neg$id <- 
      paste0(queryGRanges.neg$id, "_neg")
    strand(queryGRanges.neg) <- "-"
    
    queryGRanges <- do.call("c", list(queryGRanges[-unstranded],
                                      queryGRanges.pos,
                                      queryGRanges.neg))
    }

  #check for duplicated query ids
  if(any(duplicated(queryGRanges$id))){
    message(paste0(length(which(duplicated(queryGRanges$id)))," query ids are not unique"))
    message("Check output for new names or rename")
    queryGRanges$id <- make.names(queryGRanges$id, unique=TRUE)
  }
  
  #find 3'/5'exons
  if(length(queryGRanges) > 0){
    queryGRanges.loc <- getQueryLoc(queryGRanges, queryType="SNP", 
                                    maxDist = maxDist, filter = filter,
                                    exons = exons)
    return(queryGRanges.loc)
  }

}

#' Get locations of the first five AG 3' splice site motifs
#'
#' Takes a variable length vector of distances to the AG motif,
#' sorts and returns the first five.
#' If there are less than five elements in the vector, returns the sorted vector
#' and fills the remainder of the values with 300.
#' @param ag Vector of distances to the AG splice site motif.
#' @return Locations of the first five AG dinucleotides
#' @keywords internal
#' @author Beth Signal

getCanonical3SS <- function(ag){
  ag <- sort(ag)
  #get first five matches
  ag <- ag[1:5]
  #if less than 5 matches, replace remainder with 300
  ag[is.na(ag)] <- 300

  return(ag)
}

#' Get the best polypyramidine tract
#'
#' Takes a query genomic sequence, finds all potential polypyramidine tracts (PPTs)
#' between the test site and the annotated 3'exon.
#' Returns the distance to the start of the longest PPT, and its length.
#' @param attributes query attributes GenomicRanges
#' @return distance to the start of the longest PPT, and its length
#' @import plyr
#' @keywords internal
#' @author Beth Signal

getPPT <- function(attributes){

  dist3prime <- as.numeric(attributes$to_3prime_point)

  #get sequence between the tested site and 3'exon
  seq <- substr(attributes$seq, 251, (250 + dist3prime))
  seq <- unlist(strsplit(seq, ""))

  pyramidines <- which(seq == "T" | seq == "C")

  if(length(pyramidines) >1){
    pyraDist <- rep(NA, length(pyramidines)-1)

    #get distance to the next pyramidine
    for(p in 2:length(pyramidines)){
      pyraDist[p-1] <- pyramidines[p] - pyramidines[p-1]
    }

    longestRun <- 0
    bestRun <- 0
    bestStart <- 0
    percentPyra <- 0
    start <- 1
    sets <- length(pyraDist) + 1
    startVec <- rep(NA, sets)
    runVec <- rep(NA, sets)
    percentPyraVec <- rep(NA, sets)

    #find best PPT
    for(p in seq_along(pyraDist)){

      #For the first instance of at least 2 sequential pyramidines
      if(pyraDist[p] == 1 & longestRun == 0){
        longestRun <- 1
        start <- p
        seq.p <- seq[(pyramidines[start]):(pyramidines[start+longestRun])]
        percentPyra <- length(which(seq.p=="C"|seq.p=="T"))/length(seq.p)

        if(longestRun > bestRun){
          bestRun <- longestRun
          bestStart <- start
          bestPercent <- percentPyra
        }


        #allowing gaps with one purine, grow the tract
      }else if(pyraDist[p] == 1 | pyraDist[p] == 2){
        longestRun <- longestRun + 1
        seq.p <- seq[(pyramidines[start]):(pyramidines[start+longestRun])]
        percentPyra <- length(which(seq.p == "C"|seq.p == "T"))/length(seq.p)

        if(longestRun > bestRun){
          bestRun <- longestRun
          bestStart <- start
          bestPercent <- percentPyra
        }

        #once too many purines are encontered, save tract
      }else{
        startVec[p] <- bestStart
        runVec[p] <- longestRun
        percentPyraVec[p] <- percentPyra
        longestRun <- 0
        start <- p + 1
        bestStart <- start
      }
    }

    #add the last PPT
    startVec[sets] <- start
    runVec[sets] <- longestRun
    percentPyraVec[sets] <- percentPyra

    #make into data.frame
    pyra.df <- data.frame(set=c(1:length(runVec)), runVec,startVec,percentPyraVec)
    pyra.df <- pyra.df[which(!is.na(pyra.df$startVec)),]
    pyra.df <- plyr::arrange(pyra.df, plyr::desc(runVec))

    bestStart <- pyra.df$startVec[which.max(pyra.df$runVec)]
    bestRun <- pyra.df$runVec[which.max(pyra.df$runVec)]

    #If PPTs are long enough, shorten to get pyramidine content above 80%
    pyra.df <- pyra.df[pyra.df$runVec >=10,]
    if(dim(pyra.df)[1] != 0){
      run.extend <- rep(NA, length(pyra.df[,1]))
      start.extend <- rep(NA, length(pyra.df[,1]))
      polyper.extend <- rep(NA, length(pyra.df[,1]))

      for(py in seq_along(length(pyra.df[,1]))){
        seq.p <- seq[(pyramidines[pyra.df$startVec[py]]):(pyramidines[pyra.df$startVec[py]+pyra.df$runVec[py]])]
        startp <- 1

        run <- length(seq.p)

        polyper.extend[py] <- pyra.df$percentPyraVec[py]
        while(polyper.extend[py] < 0.8 & run >= 10){
          purine <- which(seq.p == "A"| seq.p == "G")
          purine.neg <- (length(seq.p) +1 -purine)*-1
          purine.both <- c(purine,purine.neg)
          minPurine <- which.min(abs(purine.both))

          point <- purine.both[minPurine]

          if(point < 0){
            rm <- length(seq.p)-point*-1
            newSeq <- seq.p[1:rm]
            run <- length(newSeq)
          }else{
            newSeq <- seq.p[(point+1):length(seq.p)]
            run <- length(newSeq)
            startp <- startp+point
          }
          polyper.extend[py] <-
            length(which(newSeq == "C" | newSeq == "T")) / length(newSeq)
          seq.p <- newSeq
        }

        start.extend[py] <- (pyramidines[pyra.df$startVec[py]])+startp-1
        run.extend[py] <- run
      }

      bestStart <- start.extend[which.max(run.extend)]
      bestRun <- run.extend[which.max(run.extend)]
    }


    line <- c(bestStart,bestRun)

    #if only 1 pyramidine
  }else if(length(pyramidines) == 1){
    line <- c(pyramidines, 1)
    #if no pyramidines
  }else{
    line <- c(0,0)
  }
  return(line)
}


#' Get branchpoint sequence features
#' Gets intronic sequence covering the branchpoint window and extracts predictive features
#' @param query branchpointer query GenomicRanges
#' @param rmChr remove "chr" before chromosome names before writing bed file.
#' Required if genome sequence names do not contain "chr"
#' @param queryType type of branchpointer query. "SNP" or "region".
#' @param genome .fa genome file location
#' @param bedtoolsLocation bedtools binary location (which bedtools)
#' @param uniqueId unique string identifier for intermediate .bed and .fa files.
#' @param workingDirectory directory where intermediate .bed and .fa are located
#' @param useParallel use parallelisation to speed up code?
#' @param cores number of cores to use in parallelisation (default = \code{1})
#' @param BSgenome BSgenome object
#' @return GenomicRanges with all features required to predict branchpoint probability scores
#' @importClassesFrom Biostrings DNAStringSet
#' @importFrom Biostrings complement
#' @importFrom Biostrings getSeq
#' @importFrom BSgenome.Hsapiens.UCSC.hg38 BSgenome.Hsapiens.UCSC.hg38
#' @importFrom data.table fread
#' @importFrom Seqinfo seqlevels
#' @importFrom Seqinfo seqnames
#' @importClassesFrom data.table data.table
#' @keywords internal
#' @author Beth Signal

getBranchpointSequence <- function(query, uniqueId = "test",
                                   queryType,
                                   workingDirectory = ".",
                                   genome = NA,
                                   bedtoolsLocation = NA,
                                   BSgenome = NULL,
                                   useParallel = FALSE,
                                   cores = 1,
                                   rmChr = FALSE) {
  
  if(is.na(genome) & is.null(BSgenome)){
    stop("please specify a genome .fa file for sequence extraction or specify a BSgenome object")
  }

  if((is.na(genome) | is.na(bedtoolsLocation))& is.null(BSgenome)){
    stop("please specify a genome .fa file for sequence extraction and a bedtools binary location")
  }

  if(useParallel){
    maxCores <- parallel::detectCores()

    if(maxCores < cores){
      message(paste0("specified cores (", cores,") is greater than available cores(", maxCores,")"))
      message(paste0("using all available cores"))
      cores <- maxCores
    }
  }

  #make bed format file
  if(missing(queryType) | !(queryType %in% c("SNP", "region"))){
    stop("please specify queryType as \"region\" or \"SNP\"")
  }else if (queryType == "SNP") {
    bed <- query
    start(ranges(bed)) <- as.integer(start(ranges(bed)) - 1)
  }else if (queryType == "region") {
    bed <- query
    start(ranges(bed))[as.logical(strand(bed)== "+")] <-
      end(ranges(bed))[as.logical(strand(bed)== "+")]
    start(ranges(bed)) <- start(ranges(bed)) - 1
    width(ranges(bed)) <- 2
  }

  #extend bed file to cover +/- 250 nt from each query point
  start(ranges(bed))[which(as.logical(strand(bed) == "+"))] <-
    as.integer(start(ranges(bed)) - 250 -
                 (44 - query$to_3prime))[which(as.logical(strand(bed) == "+"))]
  start(ranges(bed))[which(as.logical(strand(bed) == "-"))] <-
    as.integer(start(ranges(bed)) - 277 +
                 (44 - query$to_3prime))[which(as.logical(strand(bed) == "-"))]
  width(ranges(bed))  <- 529


  if(!is.na(genome) & !missing(bedtoolsLocation)){
    #convert to .fasta using bedtools
    bedTable <- data.frame(seqnames(bed),
                           start(ranges(bed)),
                           end(ranges(bed)),
                           bed$id,
                           score=0,
                           strand(bed))

    if (rmChr == TRUE) {
      bedTable[,1] <- gsub("chr","", bedTable[,1])
    }

    utils::write.table(
      bedTable, sep = "\t", file = paste0(workingDirectory,"/mutation_",
                                          uniqueId,".bed"),
      row.names = FALSE,col.names = FALSE,quote = FALSE)
    cmd <- paste0(
      bedtoolsLocation," getfasta -fi ", genome,
      " -bed ",workingDirectory,"/mutation_",uniqueId,".bed -fo ",
      workingDirectory,"/mutation_",uniqueId,".fa -name -s")
    system(cmd)
    
    info <- file.info(paste0(workingDirectory,"/mutation_",uniqueId,".fa"))
    if(info$size > 0){
      fasta <-
        data.table::fread(paste0(workingDirectory,"/mutation_",uniqueId,".fa"),
                          header = FALSE, stringsAsFactors = FALSE)
      fasta <- as.data.frame(fasta)
      system(paste0("rm -f ",workingDirectory,"/mutation_",uniqueId,"*"))
  
      s <- fasta[seq(2,dim(fasta)[1],by = 2),1]
      mcols(query)$seq <- s
    }else{
      stop("cannot retrieve fa sequence, please check your exon annotation and genome .fa")
    }

  }else{
    # need to +1 for BSgenomes sequence retreval
    # ranges given are bedtools (legacy)
    
    start(ranges(bed)) <- start(ranges(bed)) +1
    width(ranges(bed))  <- 528
    
    # check if chromosomes need to renamed
    seqlevels.genome <- Seqinfo::seqlevels(BSgenome)
    seqlevels.bed <- Seqinfo::seqlevels(bed)
    
    # used chromosomes 
    seqnames.bed <- as.character(Seqinfo::seqnames(bed))
    
    if(!(all(seqnames.bed %in% seqlevels.genome))){
      
      # try adding/removing chr from bed
      if(!all(stringr::str_sub(seqlevels.bed, 1, 3) == "chr")){
         Seqinfo::seqlevels(bed) <- paste0("chr", seqlevels.bed)
      }else if(all(stringr::str_sub(seqlevels.bed, 1, 3) == "chr")){
         Seqinfo::seqlevels(bed) <- gsub("chr", "", seqlevels.bed)
      }
      
      seqlevels.bed <- Seqinfo::seqlevels(bed)
      seqnames.bed <- as.character(Seqinfo::seqnames(bed))
      
      # if that doesn't fix the issue, break
      if(!(all(seqnames.bed %in% seqlevels.genome))){
        stop("Chromosome names of query and genome do not match")
      }
    }
    
    bed.seq <- suppressWarnings(Biostrings::getSeq(BSgenome, bed))
    mcols(query)$seq <- as.character(bed.seq)
  }

  ##mutate at SNP location
  if (queryType == "SNP") {
    #location of SNP
    loc <- 44 - query$to_3prime
    nt.ref <- as.character(query$ref_allele)
    nt.alt <- as.character(query$alt_allele)

    #change to compliment if on negative strand
    nt.ref[which(as.logical(strand(query) == "-"))] <-
      as.character(Biostrings::complement(Biostrings::DNAStringSet(nt.ref[which(as.logical(strand(query) == "-"))])))
    nt.alt[which(as.logical(strand(query) == "-"))] <-
      as.character(Biostrings::complement(Biostrings::DNAStringSet(nt.alt[which(as.logical(strand(query) == "-"))])))

    #check ref allele
    refAlleleCorrect <- substr(query$seq, 251 + (loc),251 + (loc)) == nt.ref

    if (any(!refAlleleCorrect)) {
      rm <- which(refAlleleCorrect == FALSE)
      if (all(refAlleleCorrect[which(as.logical(strand(query) == "-"))] == FALSE) &
          all(refAlleleCorrect[which(as.logical(strand(query) == "+"))])) {
        message("reference alleles are incorrect for all negative strand introns")
        message("please input alleles as positive strand sequences")
      }else{
        message("reference alleles do not match sequence for:")
        message(paste(query$id[rm], collapse = "\n"))
      }
      message("removing from analysis")
      query <- query[-rm]
      nt.ref <- nt.ref[-rm]
      nt.alt <- nt.alt[-rm]
    }
  }

  #create 501nt sequences with each query point centered at 251
  seqs <- data.frame(seq = rep(query$seq, 27))
  seqs$i <- rep(18:44, each = length(query$seq))
  seqs <- apply(seqs, 1, function(x) substr(x[1],
                                           (as.numeric(x[2])-17),
                                           (as.numeric(x[2])-17) + 500))

  if (queryType == "SNP") {
    #create mutated sequence
    s.mut <-
      paste0(substr(query$seq, 1,250 + (loc)), nt.alt,
             substr(query$seq, 252 + (loc),528))


    seqs.mut <- data.frame(seq = rep(s.mut, 27))
    seqs.mut$i <- rep(18:44, each = length(s.mut))
    seqs.mut <- apply(seqs.mut, 1, function(x) substr(x[1],
                                              (as.numeric(x[2])-17),
                                              (as.numeric(x[2])-17) + 500))

    queryAllPoints <- rep(query, 27)
    queryAllPoints <- rep(queryAllPoints, 2)

    mcols(queryAllPoints)$status <- c(rep("REF", length(seqs)),
                                               rep("ALT", length(seqs.mut)))

    queryAllPoints$seq <- c(seqs, seqs.mut)
    mcols(queryAllPoints)$to_3prime_point <-
      rep(rep(44:18,each = length(query$id)),2)
  }else{
    queryAllPoints <- rep(query, 27)
    mcols(queryAllPoints)$status <- rep("REF", length(seqs))
    queryAllPoints$seq <- seqs
    mcols(queryAllPoints)$to_3prime_point <-
      rep(44:18,each = length(query$seq))
  }

  mcols(queryAllPoints)$to_5prime_point <-
    (queryAllPoints$to_3prime + queryAllPoints$to_5prime) -
    queryAllPoints$to_3prime_point

  testSite <- start(ranges(queryAllPoints))
  posStrand <- which(as.logical(strand(queryAllPoints) == "+"))
  negStrand <- which(as.logical(strand(queryAllPoints) == "-"))
  testSite[posStrand] <- end(ranges(queryAllPoints))[posStrand]
  testSite[posStrand] <- (testSite + queryAllPoints$to_3prime -
                            queryAllPoints$to_3prime_point)[posStrand]
  testSite[negStrand] <- (testSite - queryAllPoints$to_3prime +
                            queryAllPoints$to_3prime_point)[negStrand]
  mcols(queryAllPoints)$test_site <- testSite

  #get sequence identity at position -5 to +5 relative to testing point
  mcols(queryAllPoints)$seq_pos0 <-
    factor(substr(queryAllPoints$seq,251,251), levels = c("A","C","G","T"))
  mcols(queryAllPoints)$seq_pos1 <-
    factor(substr(queryAllPoints$seq,252,252), levels = c("A","C","G","T"))
  mcols(queryAllPoints)$seq_pos2 <-
    factor(substr(queryAllPoints$seq,253,253), levels = c("A","C","G","T"))
  mcols(queryAllPoints)$seq_pos3 <-
    factor(substr(queryAllPoints$seq,254,254), levels = c("A","C","G","T"))
  mcols(queryAllPoints)$seq_pos4 <-
    factor(substr(queryAllPoints$seq,255,255), levels = c("A","C","G","T"))
  mcols(queryAllPoints)$ seq_pos5 <-
    factor(substr(queryAllPoints$seq,256,256), levels = c("A","C","G","T"))
  mcols(queryAllPoints)$seq_neg1 <-
    factor(substr(queryAllPoints$seq,250,250), levels = c("A","C","G","T"))
  mcols(queryAllPoints)$seq_neg2 <-
    factor(substr(queryAllPoints$seq,249,249), levels = c("A","C","G","T"))
  mcols(queryAllPoints)$seq_neg3 <-
    factor(substr(queryAllPoints$seq,248,248), levels = c("A","C","G","T"))
  mcols(queryAllPoints)$seq_neg4 <-
    factor(substr(queryAllPoints$seq,247,247), levels = c("A","C","G","T"))
  mcols(queryAllPoints)$seq_neg5 <-
    factor(substr(queryAllPoints$seq,246,246), levels = c("A","C","G","T"))

  #find canonical AG splice dinucleotides
  f <- gregexpr("AG",substr(queryAllPoints$seq, 252,501),perl = TRUE)

  if (useParallel) {
    cluster <- parallel::makeCluster(cores)
    canonHits <- parallel::parLapply(cluster,f, getCanonical3SS)
    pyra <-
        parallel::parLapply(cluster,queryAllPoints, getPPT)
    parallel::stopCluster(cluster)
  }else{
    canonHits <- lapply(f, getCanonical3SS)
    pyra <- lapply(seq_along(queryAllPoints),
                   function(i) getPPT(queryAllPoints[i]))
  }

  canon <- matrix(unlist(canonHits), ncol = 5, byrow = TRUE)
  canon <- as.data.frame(canon, stringsAsFactors=FALSE)
  colnames(canon) <-
    c("canon_hit1", "canon_hit2", "canon_hit3", "canon_hit4", "canon_hit5")

  mcols(queryAllPoints) <- cbind(mcols(queryAllPoints), canon)
  mcols(queryAllPoints)$ppt_start <- unlist(lapply(pyra, "[[", 1))
  mcols(queryAllPoints)$ppt_run_length <- unlist(lapply(pyra, "[[", 2))

  mcols(queryAllPoints)$seq <-
    stringr::str_sub(queryAllPoints$seq, (251 +
                       queryAllPoints$to_3prime_point - 50),(250 +
    queryAllPoints$to_3prime_point))

  return(queryAllPoints)
}

#' Predict branchpoint probability scores
#'
#' predicts branchpoint probability scores for each query site.
#' @param query branchpointer query GenomicRanges
#' @param rmChr remove "chr" before chromosome names before writing bed file.
#' Required if genome sequence names do not contain "chr"
#' @param queryType type of branchpointer query. "SNP" or "region".
#' @param genome .fa genome file location
#' @param bedtoolsLocation bedtools binary location (which bedtools)
#' @param uniqueId unique string identifier for intermediate .bed and .fa files.
#' @param workingDirectory directory where intermediate .bed and .fa are located
#' @param useParallel use parallelisation to speed up code?
#' @param cores number of cores to use in parallelisation (default = \code{1})
#' @param BSgenome BSgenome object
#' @return GenomicRanges object with branchpoint probaility scores for each site in query
#' @export
#' @import caret
#' @importFrom kernlab predict
#' @importClassesFrom kernlab ksvm
#' @import gbm
#' @import parallel
#' @importFrom stringr str_sub
#' @examples
#' smallExons <- system.file("extdata","gencode.v26.annotation.small.gtf",
#' package = "branchpointer")
#' exons <- gtfToExons(smallExons)
#' g <- BSgenome.Hsapiens.UCSC.hg38::BSgenome.Hsapiens.UCSC.hg38
#'
#' querySNPFile <- system.file("extdata","SNP_example.txt", package = "branchpointer")
#' querySNP <- readQueryFile(querySNPFile,queryType = "SNP",exons = exons, filter = FALSE)
#' predictionsSNP <- predictBranchpoints(querySNP,queryType = "SNP",BSgenome = g)
#' @author Beth Signal

predictBranchpoints <- function(query, uniqueId = "test",
                                     queryType,
                                     workingDirectory = ".",
                                     genome = NA,
                                     bedtoolsLocation = NA,
                                     BSgenome = NULL,
                                     useParallel = FALSE,
                                     cores = 1,
                                     rmChr = FALSE){
  if(useParallel){

    maxCores <- parallel::detectCores()

    if(maxCores < cores){

      message(paste0("specified cores (", cores,") is greater than available cores(", maxCores,")"))
      message(paste0("using all available cores"))
      cores <- maxCores

    }

  }

  queryAttributes <- getBranchpointSequence(query, uniqueId = uniqueId,
                                            queryType = queryType,
                                            workingDirectory = workingDirectory,
                                            genome = genome,
                                            bedtoolsLocation = bedtoolsLocation,
                                            BSgenome = BSgenome,
                                            useParallel = useParallel,
                                            cores = cores,
                                            rmChr = rmChr)

  #convert to data.frame for kernlab/caret

  queryAttributes.forModel <- as.data.frame(mcols(queryAttributes))

  colNamesForDataFrame <- HCN_names[-1]
  colNamesForDataFrame <- gsub("new_ID", "id",
                               colNamesForDataFrame)
  colNamesForDataFrame <- gsub("dist.1", "to_5prime_point",
                               colNamesForDataFrame)
  colNamesForDataFrame <- gsub("dist.2", "to_3prime_point",
                               colNamesForDataFrame)

  queryAttributes.forModel <- queryAttributes.forModel[,colNamesForDataFrame]
  queryAttributes.forModel <- cbind(set = "UNKNOWN", queryAttributes.forModel)
  colnames(queryAttributes.forModel) <-  HCN_names

  #remove any rows with NA values
  isNA <- apply(queryAttributes.forModel[,-c(1,2)], 2, is.na)
  isNAv <- apply(isNA,1, any)
  rm <- which(isNAv == TRUE)
  if(length(rm) > 0){
    queryAttributes.forModel <- queryAttributes.forModel[-rm,]
    queryAttributes <- queryAttributes[-rm,]
  }

  #convert sequences to dummy vars
  queryAttributes.dummies <-
    predict(dummies, newdata = queryAttributes.forModel[,-2])
  queryAttributes.forModel <-
    cbind(set = queryAttributes.forModel$set, queryAttributes.dummies)
  queryAttributes.forModel <- apply(queryAttributes.forModel[,-1],2,as.numeric)

  #make sure all dummy vars are accounted for
  if(any(is.na(match(names(preProcValues$mean), colnames(queryAttributes.forModel))))){
    newColNames <- names(preProcValues$mean)[which(is.na(match(names(preProcValues$mean),
                                                                 colnames(queryAttributes.forModel))))]
    dfAdd <- as.data.frame(matrix(data=0,nrow=nrow(queryAttributes.forModel),
                                   ncol=length(newColNames)))
    colnames(dfAdd) <- newColNames
    queryAttributes.forModel <- cbind(queryAttributes.forModel, dfAdd)
    queryAttributes.forModel <-
      queryAttributes.forModel[,match(names(preProcValues$mean),
                                      colnames(queryAttributes.forModel))]
  }

  #pre-process values
  queryAttributes.forModel <- predict(preProcValues, queryAttributes.forModel)
  queryAttributes.forModel <- cbind(queryAttributes.forModel, Class="UNKNOWN")
  queryAttributes.forModel <-
    as.data.frame(queryAttributes.forModel, stringsAsFactors=FALSE)
  queryAttributes.forModel$Class <- as.factor(queryAttributes.forModel$Class)
  for(n in 1:(length(colnames(queryAttributes.forModel)) -1)){
    queryAttributes.forModel[,n] <- as.numeric(queryAttributes.forModel[,n])
  }

  #gbm prediction
  p <- predict(object = branchpointer2.gbm,
               queryAttributes.forModel,"prob")

  #reconfigure
  mcols(queryAttributes)$branchpoint_prob <- p[,1]
  
  #### U2 binding energy###
  m <- match(colnames(U2_binding_df)[-c(1:3)],colnames(mcols(queryAttributes)))
  U2Eightmers <- do.call(paste0, as.data.frame(mcols(queryAttributes)[,m]))
  
  x <- match(U2Eightmers, U2_binding_df$eightmers)
  mcols(queryAttributes)$U2_binding_energy <- U2_binding_df$energy[x]

  return(queryAttributes)
}

#' Plots transcript structures
#'
#' Plots transcript structures
#' @param exonID id of the exon to plot
#' @param exons Granges containing exon co-ordinates.
#' @param keepTranscripts which transcripts to plot (\code{"overlapping"} or \code{"withExon"})
#' \code{"overlapping"} will plot all transcripts overlapping the exon, 
#' whereas \code{"withExon"} will plot all transcripts containing the exon.
#' @return ggplot2 plot transcript structures
#' @import ggplot2
#' @keywords internal
#' @author Beth Signal
plotStructure <- function(exonID, exons, keepTranscripts="overlapping"){
  
  geneID <- exons$gene_id[match(exonID, exons$exon_id)]
  
  exonsForPlot <- exons[exons$gene_id == geneID]  
  
  exonsForPlot <- cbind(chromosome=as.character(seqnames(exonsForPlot)), 
                        as.data.frame(ranges(exonsForPlot)),
                        strand=as.character(strand(exonsForPlot)),
                        as.data.frame(mcols(exonsForPlot)))
  
  exonsForPlot$start <- as.numeric(exonsForPlot$start)
  exonsForPlot$end <- as.numeric(exonsForPlot$end)
  
  transcriptsForPlot <- exonsForPlot
  transcriptsForPlot$transcript_id <- transcriptsForPlot$gene_id
  exonsForPlot <- rbind(exonsForPlot, transcriptsForPlot)  
  
  exonsForPlot$length <- exonsForPlot$end - exonsForPlot$start
  
  
  if (as.logical(exonsForPlot$strand[1] == "+")) {
    BPexons = which(exonsForPlot$start ==
                      exonsForPlot$start[which(exonsForPlot$exon_id ==
                                                 exonID)][1])
  }else{
    BPexons <- which(exonsForPlot$end ==
                       exonsForPlot$end[which(exonsForPlot$exon_id ==
                                                exonID)][1])
  }
  
  exonsForPlot$SNP_exon <- 0
  exonsForPlot$SNP_exon[BPexons] <- 1
  exonsForPlot$SNP_exon[exonsForPlot$transcript_id == exonsForPlot$gene_id[1]] <- 2
  
  #make smaller data.frame for plotting connecting lines
  exonsForPlotLines <- exonsForPlot[!duplicated(exonsForPlot$transcript_id),]
  
  exonsForPlotLines <- stats::aggregate(start ~ transcript_id, exonsForPlot, max)
  exonsForPlotLines <- cbind(exonsForPlotLines, 
                             stats::aggregate(end ~ transcript_id, exonsForPlot, min)[,2],
                             stats::aggregate(end ~ transcript_id, exonsForPlot, max)[,2],
                             stats::aggregate(start ~ transcript_id, exonsForPlot, min)[,2])
  
  colnames(exonsForPlotLines) <- c("transcript_id", "maxs","mine","maxe","mins")
  
  #only plot exonsForPlot overlapping the query
  if(keepTranscripts == "overlapping"){
    keep <- which((exonsForPlotLines$maxe >= max(exonsForPlot$end[exonsForPlot$SNP_exon == 1])) &
                    (exonsForPlotLines$mins <= min(exonsForPlot$start[exonsForPlot$SNP_exon == 1])))
    exonsForPlotLines <- exonsForPlotLines[keep,]
    exonsForPlot <- exonsForPlot[exonsForPlot$transcript_id %in% exonsForPlotLines$transcript_id,]
  }else if(keepTranscripts == "withExon"){
    keep <- which(exonsForPlotLines$transcript_id %in% exonsForPlot$transcript_id[exonsForPlot$SNP_exon == 1])
    exonsForPlotLines <- exonsForPlotLines[keep,]
    exonsForPlot <- exonsForPlot[exonsForPlot$transcript_id %in% exonsForPlotLines$transcript_id,]
  }
  
  exonsForPlot$transcript_id_num <- as.numeric(as.factor(exonsForPlot$transcript_id)) * -1
  exonsForPlotLines$transcript_id_num <- as.numeric(as.factor(exonsForPlotLines$transcript_id)) * -1
  
  if (as.logical(exonsForPlot$strand[1] == "+")) {
    exonsForPlotLines$transcript_id <- paste0(exonsForPlotLines$transcript_id, " (+)")
  }else{
    exonsForPlotLines$transcript_id <- paste0(exonsForPlotLines$transcript_id, " (-)")
  }
  exonsForPlotLines$SNP_exon <- 0
  
  plot.structure <- ggplot() +
    geom_segment(data = exonsForPlotLines, aes_string(x = 'mins',xend = 'maxe', y = 'transcript_id_num',
                                                      yend = 'transcript_id_num')) +
    geom_rect(data=exonsForPlot, aes_string(xmin = 'start', xmax = 'start + length',
                                            ymin = 'transcript_id_num - 0.4',
                                            ymax = 'transcript_id_num + 0.4', fill = 'factor(SNP_exon)')) +
    scale_fill_manual(values = c("black","blue","grey60")) +
    scale_y_continuous(breaks = seq(-1, min(exonsForPlotLines$transcript_id_num),-1),
                       labels = exonsForPlotLines$transcript_id[
                         match(seq(-1, min(exonsForPlotLines$transcript_id_num),-1),
                               exonsForPlotLines$transcript_id_num)]) +
    theme(panel.background = element_rect(fill = "white"), axis.text.x = element_blank(),
          axis.title.x = element_blank(), axis.ticks.x = element_blank(),
          axis.title.y = element_blank(), axis.ticks.y = element_blank(),
          legend.position = "none")
  
  return(plot.structure)
}

#' Plots branchpointer predictions
#'
#' Plots branchpointer predictions
#' @param queryName query id used to identify the SNP or region
#' @param predictions Granges object generated by predictBranchpoints()
#' @param probabilityCutoff probability score cutoff value for displaying U2 binding energy
#' @param plotStructure plot structures for gene and 3' exon containing and skipping isoforms
#' @param plotMutated plot alternative sequence predicitons alongside reference sequence predictions
#' @param exons Granges containing exon co-ordinates.
#' Should be produced by gtfToExons()
#' @return ggplot2 plot with branchpoint features in the specified intronic region
#' @export
#' @import ggplot2
#' @importFrom cowplot ggdraw
#' @importFrom cowplot draw_plot
#' @examples
#' smallExons <- system.file("extdata","gencode.v26.annotation.small.gtf",
#' package = "branchpointer")
#' exons <- gtfToExons(smallExons)
#' g <- BSgenome.Hsapiens.UCSC.hg38::BSgenome.Hsapiens.UCSC.hg38
#'
#' querySNPFile <- system.file("extdata","SNP_example.txt", package = "branchpointer")
#' querySNP <- readQueryFile(querySNPFile,queryType = "SNP",exons = exons, filter = FALSE)
#' predictionsSNP <- predictBranchpoints(querySNP,queryType = "SNP",BSgenome = g)

#' plotBranchpointWindow(querySNP$id[1], predictionsSNP,
#' plotMutated = TRUE, exons = exons)
#' @author Beth Signal

plotBranchpointWindow <- function(queryName,
                                 predictions,
                                 probabilityCutoff = 0.52,
                                 plotMutated = FALSE,
                                 plotStructure = TRUE,
                                 exons) {
  #find the query
  ind <- which(!is.na(match(predictions$id, queryName)))
  predictions.snp <- predictions[which(predictions$id == queryName)]

  predictions.snp$to_3prime_point <- predictions.snp$to_3prime_point * -1
  
  predictions.snp.ref <- as.data.frame(mcols(predictions.snp)[predictions.snp$status == "REF",])
  colnames(predictions.snp.ref) <- gsub("to_3prime_point","distance",colnames(predictions.snp.ref))
  colnames(predictions.snp.ref) <- gsub("seq_pos0","nucleotide",colnames(predictions.snp.ref))
  predictions.snp.ref$nucleotide <- as.character(predictions.snp.ref$nucleotide)
  
  #make plots for reference sequence
  
  #probability score by sequence position
  plot.prob.ref <- ggplot(predictions.snp.ref, aes_string(x = 'distance', y = 'branchpoint_prob', fill = 'nucleotide',
                                           col = 'nucleotide',alpha = 'U2_binding_energy')) +
    geom_bar(stat = "identity") +
    scale_y_continuous(name = "branchpointer probability score",limits = c(0,1),
                       breaks = seq(0,1,0.10), labels = c("0.00","0.10","0.20","0.30","0.40","0.50",
                                                          "0.60","0.70","0.80","0.90","1.00")) +
    scale_fill_manual(values = mercer_nt_cols, drop = TRUE,
                      limits = c("A","C","G","T")) +
    scale_color_manual(values = mercer_nt_cols,drop = TRUE,
                       limits = c("A","C","G","T")) +
    theme(legend.position = "none", axis.text.x = element_blank(), axis.title.x = element_blank(),
          axis.ticks.x = element_blank()) +
    scale_x_continuous(limits = c(-45,-17))

  #U2 binding energy by sequence position
  plot.U2.ref <- ggplot(predictions.snp.ref[predictions.snp.ref$branchpoint_prob >= probabilityCutoff,],
              aes_string(x = 'distance', y = 'U2_binding_energy')) +
    geom_bar(stat = "identity",width = 1) +
    scale_x_continuous(limits = c(-45,-17), labels = seq(45,17,-5),
                       breaks = seq(-45,-17, 5), name ="Distance to 3' exon (nt)") +
    theme(legend.position = "none") +
    scale_y_continuous(name = "U2 binding energy",limits = c(0,10),
                       breaks = seq(0,9,3), labels = c("0.00","3.00","6.00","9.00"))

  #Sequence identity
  plot.seq.ref <- ggplot(predictions.snp.ref, aes_string(x = 'distance', y = 1, col = 'nucleotide',label = 'nucleotide')) +
    geom_text(size = 4, family = "Courier") +
    scale_color_manual(values = mercer_nt_cols,drop = TRUE,
                       limits = c("A","C","G","T")) +
    theme(legend.position = "none",axis.text.y = element_text(colour = "white"),
          axis.title.y = element_text(colour ="white"), axis.ticks.y = element_line(color = "white"),
          panel.background = element_rect(fill = "white"), axis.text.x = element_blank(),
          axis.title.x = element_blank(), axis.ticks.x = element_blank()) +
    scale_x_continuous(limits = c(-45,-17))

  if (plotMutated == TRUE) {
    
    predictions.snp.alt <- as.data.frame(mcols(predictions.snp)[predictions.snp$status == "ALT",])
    colnames(predictions.snp.alt) <- gsub("to_3prime_point","distance",colnames(predictions.snp.alt))
    colnames(predictions.snp.alt) <- gsub("seq_pos0","nucleotide",colnames(predictions.snp.alt))
    predictions.snp.alt$nucleotide <- as.character(predictions.snp.alt$nucleotide)
    
    #probability score by sequence position
    plot.prob.alt <- ggplot(predictions.snp.alt, aes_string(x = 'distance', y = 'branchpoint_prob', fill = 'nucleotide',
                                             col = 'nucleotide',alpha = 'U2_binding_energy')) +
      geom_bar(stat = "identity") +
      scale_y_continuous(name = "branchpointer probability score",limits = c(0,1),
                         breaks = seq(0,1,0.10), labels = c("0.00","0.10","0.20","0.30","0.40","0.50",
                                                            "0.60","0.70","0.80","0.90","1.00")) +
      scale_fill_manual(values = mercer_nt_cols, drop = TRUE,
                        limits = c("A","C","G","T")) +
      scale_color_manual(values = mercer_nt_cols,drop = TRUE,
                         limits = c("A","C","G","T")) +
      theme(legend.position = "none", axis.text.x = element_blank(), axis.title.x = element_blank(),
            axis.ticks.x = element_blank()) +
      scale_x_continuous(limits = c(-45,-17)) + ggtitle("Alternative")

    plot.prob.ref <- plot.prob.ref + ggtitle("Reference")

    #U2 binding energy by sequence position
    plot.U2.alt <- ggplot(predictions.snp.alt[predictions.snp.alt$branchpoint_prob >= probabilityCutoff,],
                aes_string(x = 'distance', y = 'U2_binding_energy')) +
      geom_bar(stat = "identity",width = 1) +
      scale_x_continuous(limits = c(-45,-17), labels = seq(45,17,-5),
                         breaks = seq(-45,-17, 5), name ="Distance to 3' exon (nt)") +
      theme(legend.position = "none") +
      scale_y_continuous(name = "U2 binding energy",limits = c(0,10),
                         breaks = seq(0,9,3), labels = c("0.00","3.00","6.00","9.00"))

    #Sequence identity
    plot.seq.alt <- ggplot(predictions.snp.alt, aes_string(x = 'distance', y = 1, col = 'nucleotide',label = 'nucleotide')) +
      geom_text(size = 4, family = "Courier") +
      scale_color_manual(values = mercer_nt_cols,drop = TRUE,
                         limits = c("A","C","G","T")) +
      theme(legend.position = "none",axis.text.y = element_text(colour = "white"),
            axis.title.y = element_text(colour ="white"), axis.ticks.y = element_line(color = "white"),
            panel.background = element_rect(fill = "white"), axis.text.x = element_blank(),
            axis.title.x = element_blank(), axis.ticks.x = element_blank()) +
      scale_x_continuous(limits = c(-45,-17))

    ######Get reference vs. alt sequence for 0-50 window#####
    
    seqSplit.ref <- unlist(stringr::str_split(predictions.snp.ref$seq[1], ""))
    seqSplit.alt <- unlist(stringr::str_split(predictions.snp.alt$seq[1], ""))
    
    wholeSeq <- data.frame(nt = c(seqSplit.ref, seqSplit.alt),
                           pos = rep(seq(-50,-1,1),2),
                           set = rep(c("REF","ALT"), each =50))
    mutPosition <- wholeSeq$pos[which(wholeSeq$nt[wholeSeq$set == "REF"] !=
                                    wholeSeq$nt[wholeSeq$set == "ALT"])]

    plot.seq.comparison <- ggplot(wholeSeq, aes_string(x = 'pos', y = 'set', col = 'nt',label = 'nt')) +
      geom_rect(xmin = mutPosition - 0.5,xmax = mutPosition + 0.5, ymin = 0.5, ymax = 0.5 + 2,
                col = NA, fill = "grey90") +
      geom_text(size = 4, family = "Courier") +
      scale_color_manual(values = mercer_nt_cols) +
      theme(legend.position = "none",
            axis.title.y = element_text(colour ="white"), axis.ticks.y = element_line(color = "white"),
            panel.background = element_rect(fill = "white"), axis.text.x = element_blank(),
            axis.title.x = element_blank(), axis.ticks.x = element_blank()) +
      scale_x_continuous(limits = c(-50,-1)) +
      scale_y_discrete(labels = c("Alternative", "Reference")) +
      geom_rect(xmin = -44.5,xmax = -17.5, ymin = 0.5, ymax = 0.5 + 2, fill = NA, col ="black")

  }

  #plot gene/transcript structure
  if (plotStructure == TRUE) {
    exonID <- predictions.snp$exon_3prime[1]
    plot.structure <- plotStructure(exonID, exons)
  }
    
  theme_set(theme_gray())
  if (plotStructure == TRUE & plotMutated == TRUE) {
    ggdraw() +
      draw_plot(plot.structure,0,0.775,1,0.225) + 
      draw_plot(plot.seq.comparison,0,0.675,1,0.1) +
      draw_plot(plot.prob.ref,0,.275,0.5,.40) + draw_plot(plot.seq.ref,0,.2,0.5,.075) + draw_plot(plot.U2.ref,0,0,0.5,.2) +
      draw_plot(plot.prob.alt,0.5,.275,0.5,.40) + draw_plot(plot.seq.alt,0.5,.2,0.5,.075) + draw_plot(plot.U2.alt,0.5,0,0.5,.2)

  }else if (plotStructure == TRUE & plotMutated == FALSE) {
    ggdraw() +
      draw_plot(plot.structure,0,0.775,1,0.225) +
      draw_plot(plot.prob.ref,0,.325,1,.45) + draw_plot(plot.seq.ref,0,.25,1,.075) + draw_plot(plot.U2.ref,0,0,1,.25)
  }else if (plotStructure == FALSE & plotMutated == FALSE) {
    ggdraw() +
      draw_plot(plot.prob.ref,0,.325,1,.45) + draw_plot(plot.seq.ref,0,.25,1,.075) + draw_plot(plot.U2.ref,0,0,1,.25)
  }else if (plotStructure == FALSE & plotMutated == TRUE) {
    ggdraw() +
      draw_plot(plot.seq.comparison,0,0.9,1,0.1) +
      draw_plot(plot.prob.ref,0,.4,0.5,.5) + draw_plot(plot.seq.ref,0,.3,0.5,.1) + draw_plot(plot.U2.ref,0,0,0.5,.3) +
      draw_plot(plot.prob.alt,0.5,.4,0.5,.5) + draw_plot(plot.seq.alt,0.5,.3,0.5,.1) + draw_plot(plot.U2.alt,0.5,0,0.5,.3)
  }

}

#' Convert GTF file to exon location file
#'
#' Converts a GTF annotation to exon locations
#' @param gtf file containing the gtf annotation.
#' @return exon annotation GRanges
#' @export
#' @import stringr
#' @import GenomicRanges
#' @importFrom utils write.table
#' @importFrom rtracklayer import
#' @examples
#' smallExons <- system.file("extdata","gencode.v26.annotation.small.gtf",
#' package = "branchpointer")
#' exons <- gtfToExons(smallExons)
#' @author Beth Signal

gtfToExons <- function(gtf){

  gtf.rtrack <- rtracklayer::import(gtf)

  #keep exon annotations only
  gtf.rtrack <- gtf.rtrack[gtf.rtrack$type=="exon"]

  #change "biotype" to "type" in GTFs from Ensembl
  if("gene_biotype" %in% colnames(mcols(gtf.rtrack))){
    colnames(mcols(gtf.rtrack)) <- gsub("biotype",
                                              "type",
                                        colnames(mcols(gtf.rtrack)))
  }

  if(!all(c("exon_id", "exon_number") %in% (colnames(mcols(gtf.rtrack))))){
    mcols(gtf.rtrack)$exon_number <- NA
    gtf.rtrack$exon_id <- gtf.rtrack$transcript_id

    #make exon names
    n <- 1
    while(any(is.na(gtf.rtrack$exon_number))){
      transcript_ids <- unique(gtf.rtrack$transcript_id)
      m <- match(transcript_ids,
                 gtf.rtrack$transcript_id[which(
                   is.na(gtf.rtrack$exon_number))])
      gtf.rtrack$exon_number[which(
        is.na(gtf.rtrack$exon_number))[m]] <- n
      n <- n+1
    }
  }

  exons <- gtf.rtrack
  mcols(exons) <- mcols(exons)[,c("gene_id","gene_type",
                                 "transcript_id","transcript_type",
                                 "exon_id","exon_number")]
  # close connections
  gc()

  return(exons)
}

#' Convert exon annotation GRanges to intron locations
#'
#' Converts exon annotation to intron locations overlapping the branchpoint region
#' for exculsion of non-branchpoint region SNPs
#' Returns a character vector of chromosome locations
#' @param exons GRanges containing exon co-ordinates.
#' Should be produced by gtfToExons()
#' @param maxDist Maximum distance from the 3' exon to create the branchpoint region.
#' @return GRanges containing intron window co-ordinates
#' @import GenomicRanges
#' @keywords internal
#' @author Beth Signal
exonsToIntrons <- function(exons, maxDist = 50){
  
  introns <- exons
  
  posInd <- which(as.logical(strand(exons) == "+"))
  start(introns[posInd]) <- start(introns[posInd]) - (maxDist + 1)
  end(introns[posInd]) <- start(introns[posInd]) + maxDist
  
  negInd <- which(as.logical(strand(exons) == "-"))
  end(introns[negInd]) <- end(introns[negInd]) + (maxDist + 1)
  start(introns[negInd]) <- end(introns[negInd]) - maxDist
  
  return(introns)
}

#' Get the closest 3' and 5' exons
#'
#' Finds the closest annotated exons from a genomic co-ordinate.
#' Returns the distance to the 3' exon, distance to the 5' exon,
#' ids of the 3' and 5' exon,
#' and if the exons are from the same parent gene
#' @param query GenomicRangesquery
#' @param exons GenomicRanges containing exon co-ordinates.
#' Should be produced by gtfToExons()
#' @param queryType type of query. "SNP" or "region"
#' @return GenomicRanges with distance to the closest 3' and 5' exons,
#' whether these exons are part of the same gene (i.e is the location intronic),
#' and the identifiers for the 3' and 5' exons.
#' @import GenomicRanges
#' @keywords internal
#' @author Beth Signal

getExonDists <- function(query, exons, queryType){
  
  # if using regions, region start will be used for negative strand queries
  # & region end for positive strand queries
  
  negInd <- which(as.logical(strand(query) == '-'))
  posInd <- which(as.logical(strand(query) == '+'))
  
  queryPoint <- query
  
  width(ranges(queryPoint))[negInd] <- 1
  end <- end(ranges(queryPoint))[posInd]
  start(ranges(queryPoint[posInd])) <- end
  width(ranges(queryPoint[posInd])) <- 1
  
  f <- GenomicRanges::follow(queryPoint,exons)
  gene5 <- exons$gene_id[f]
  exon5 <- exons$exon_id[f]
  
  keep <- which(!is.na(f))
  f <- f[keep]
  to5prime <- rep(NA, length(queryPoint))
  to5prime[keep] <- GenomicRanges::distance(queryPoint[keep],exons[f]) + 1
  
  
  p <- GenomicRanges::precede(queryPoint, exons)
  gene3 <- exons$gene_id[p]
  exon3 <- exons$exon_id[p]
  
  keep <- which(!is.na(p))
  p <- p[keep]
  to3prime <- rep(NA, length(queryPoint))
  to3prime[keep] <- GenomicRanges::distance(queryPoint[keep],exons[p]) + 1
  
  sameGene <- gene3 == gene5
  
  query$to_3prime <- to3prime
  query$to_5prime <- to5prime
  query$same_gene <- sameGene
  query$exon_3prime <- exon3
  query$exon_5prime <- exon5
  
  return(query)
}

#' Find the closest 3' and 5' exons to a branchpointer query
#'
#' Finds the closest annotated exons from genomic co-ordinates in a branchpointer query GRanges
#' @param query branchpointer query GenomicRanges
#' must have chromosome at position 2, genomic co-ordinate at position 3,
#' and strand at position 4.
#' @param queryType type of query file (\code{"SNP"} or \code{"region"})
#' @param exons data.frame containing exon co-ordinates.
#' Should be produced by gtfToExons()
#' @param maxDist maximum distance a SNP can be from an annotated 3' exon.
#' @param filter remove SNP queries prior to finding finding nearest exons.
#' @return GenomicRanges with the query and its location relative to the 3' and 5' exons
#' @keywords internal
#' @import GenomicRanges
#' @author Beth Signal

getQueryLoc <- function(query, queryType, maxDist=50, filter=TRUE, exons){
  
  if(missing(queryType) | !(queryType %in% c("SNP", "region"))){
    
    stop("please specify queryType as \"region\" or \"SNP\"")
    
  }
  
  if(missing(exons)){
    
    stop("please specify exon annotation object")
    
  }
  
  if(queryType=="SNP"){
    
    if(filter){
      message("filtering for SNPs in branchpoint windows")
      introns <- exonsToIntrons(exons, maxDist)
      o <- GenomicRanges::findOverlaps(query, introns)
      keep <- unique(o@from)
      query <- query[keep]
      
    }
  }
  
  nearestExons <- getExonDists(query, exons, queryType)
  
  #remove any points not in same gene
  rm <- which(nearestExons$same_gene == FALSE |
                is.na(nearestExons$exon_3prime) | 
                is.na(nearestExons$exon_5prime))
  
  if(length(rm) > 0){
    nearestExons <- nearestExons[-rm]
  }
  
  
  if(queryType=="region"){
    #if introns regions are closer to the 3'SS than the branchpoint region
    # move the region to cover the window of the nearest exon
    near3 <- which(nearestExons$to_3prime < 18)
    if(length(near3) > 0){
      addDistance <- 18 - nearestExons$to_3prime[near3]
      negStrand <- which(as.logical(strand(nearestExons)[near3] == "-"))
      posStrand <- which(as.logical(strand(nearestExons)[near3] == "+"))
      
      if(length(negStrand) > 0){
        start(ranges(nearestExons))[near3][negStrand] <- 
          start(ranges(nearestExons))[near3][negStrand] + addDistance[negStrand]
      }
      if(length(posStrand) > 0){
        end(ranges(nearestExons))[near3][posStrand] <- 
          end(ranges(nearestExons))[near3][posStrand] - addDistance[posStrand]
      }
      
    }
    
    #if introns regions are further from the 3'SS than the branchpoint region
    notNear3 <- which(nearestExons$to_3prime > 44)
    if(length(notNear3) > 0){
      nearestExons <- nearestExons[-notNear3]
    }
    
    nearestExons <- getExonDists(nearestExons,exons,queryType)
    
    #adjust query location to only cover the 27nt window
    
    #negStrand -- move end
    negStrand <- which(as.logical(strand(nearestExons) == "-"))
    if(length(negStrand) > 0){
      end(ranges(nearestExons[negStrand])) <- 
        start(ranges(nearestExons[negStrand])) - 
        nearestExons$to_3prime[negStrand] + 44
    }
    #posStrand -- move start
    posStrand <- which(as.logical(strand(nearestExons) == "+"))
    if(length(posStrand) > 0){
      start(ranges(nearestExons[posStrand])) <- 
        end(ranges(nearestExons[posStrand])) +
        nearestExons$to_3prime[posStrand] - 44
    }
    
  }else if(queryType=="SNP"){
    
    #if a 5' or 3' exon can't be found remove from analysis
    rm <- which(nearestExons$to_3prime==-1 | nearestExons$to_5prime==-1)
    if(length(rm) > 0){
      nearestExons <- nearestExons[-rm,]
    }
    
    rm <- which(nearestExons$to_3prime > maxDist)
    if(length(rm) > 0){
      nearestExons <- nearestExons[-rm,]
    }
    
    #check both exons come from the same parent gene 
    #(i.e query is in intronic region)
    rm <- which(!(nearestExons$same_gene))
    if(length(rm) > 0){
      nearestExons <- nearestExons[-rm,]
    }
  }
  return(nearestExons)
}

#' Read a query file
#'
#' Reads and formats a manually generated query file, and finds realtive locations of the closest annotated exons
#' Converts unstranded SNPs to two entries for each strand.
#' Checks for duplicate names and replaces if found.
#' @param queryFile tab delimited file containing query information.
#' For intronic regions should be in the format: region id, chromosome name, region start, region end, strand.
#' For SNP variants should be in the format: SNP id, chromosome name, SNP position, strand, reference allele (A/T/C/G), alternative allele (A/T/C/G)
#' @param queryType type of query file (\code{"SNP"} or \code{"region"})
#' @param exons GRanges containing exon co-ordinates.
#' Should be produced by gtfToExons()
#' @param maxDist maximum distance a SNP can be from an annotated 3' exon.
#' @param filter remove SNP queries prior to finding finding nearest exons.
#' @return Formatted query GRanges
#' @export
#' @import GenomicRanges
#' @importFrom data.table fread
#' @importClassesFrom data.table data.table
#' @importFrom S4Vectors Rle
#' @importFrom IRanges IRanges
#' @examples
#' smallExons <- system.file("extdata","gencode.v26.annotation.small.gtf", package = "branchpointer")
#' exons <- gtfToExons(smallExons)
#' 
#' querySNPFile <- system.file("extdata","SNP_example.txt", package = "branchpointer")
#' querySNP <- readQueryFile(querySNPFile, queryType = "SNP", exons)
#'
#' queryIntronFile <- system.file("extdata","intron_example.txt", package = "branchpointer")
#' queryIntron <- readQueryFile(queryIntronFile,queryType = "region", exons)
#' @author Beth Signal

readQueryFile <- function(queryFile, queryType, exons, maxDist=50, filter=TRUE){

  if(missing(queryType)){
    queryTest <- data.table::fread(
      queryFile,header = TRUE,
      nrows=1)

    if(ncol(queryTest) == 5){
      queryType <- "region"
      message("first line of file has 5 columns")
      message("using query_type = \"region\"")
    }else if(ncol(queryTest) == 6){
      queryType <- "SNP"
      message("first line of file has 6 columns")
      message("using query_type = \"SNP\"")
    }else{
      stop("please specify query_type and provide correctly formatted file")
    }
  }

  if (!(queryType %in% c("SNP", "region"))) {
    message("please specify query_type as \"region\" or \"SNP\"")
  }else{
    if (queryType == "SNP") {
      query <- data.table::fread(
        queryFile,header = TRUE,
        colClasses = c(
          "character", "character", "numeric",
          "character", "character", "character"
        ), data.table=FALSE)
      colnames(query)[1:6] <-
        c("id", "chromosome","chrom_start","strand","ref_allele", "alt_allele")

      #check single nts
      query$ref_allele <- toupper(query$ref_allele)
      query$alt_allele <- toupper(query$alt_allele)

      #check for unstranded queries & replace with positive & negative
      unstranded <- which(query$strand != "+" | query$strand != "-")
      if (length(unstranded) > 0) {
        query.pos <- query[unstranded,]
        query.pos$id <- paste0(query.pos$id, "_pos")
        query.pos$strand <- "+"
        query.neg <- query[unstranded,]
        query.neg$id <- paste0(query.neg$id, "_neg")
        query.neg$strand <- "-"
        query <- rbind(query[-unstranded,], query.pos,query.neg)
        }
      
      queryGRanges <- GRanges(seqnames=S4Vectors::Rle(query$chromosome),
                              ranges=IRanges::IRanges(start=query$chrom_start, width=1),
                              strand=query$strand,
                              id=query$id,
                              ref_allele=query$ref_allele,
                              alt_allele=query$alt_allele)
    }else if (queryType == "region") {
      query <- data.table::fread(
        queryFile, header = TRUE,colClasses = c(
          "character","character","numeric","numeric","character"
        ), data.table=FALSE)
      colnames(query) <-
        c("id","chromosome","chrom_start","chrom_end","strand")
      
      queryGRanges <- GenomicRanges::GRanges(
          seqnames = S4Vectors::Rle(query$chromosome),
          ranges = IRanges::IRanges(start = query$chrom_start,
                                    end = query$chrom_end),
          strand = query$strand,
          id = query$id)
    }

    #check for duplicated query ids
    if (any(duplicated(queryGRanges$id))) {
      message(paste0(length(which(
        duplicated(queryGRanges$id)
      ))," query ids are not unique"))
      message("Check output for new names or rename")
      queryGRanges$id = make.names(queryGRanges$id, unique = TRUE)
    }
    
    #find 3'/5'exons
    if(length(queryGRanges) > 0){
      queryGRanges.loc <- getQueryLoc(queryGRanges, queryType, maxDist = maxDist, filter = filter,
                                    exons = exons)
      return(queryGRanges.loc)
    }
    
  }
}

#' Convert SNP branchpoint predictions across the branchpoint window to an intronic summary
#'
#' Takes predictions of branchpoint probabilities from a reference
#' and alternative SNP and summarises the effect(s) of the SNP.
#' @param predictions site-wide branchpoint proability predictions
#' produced from predictBranchpoints()
#' @param query query GRanges containing all SNP ids to be summarised
#' @param probabilityCutoff Value to be used as the cutoff for
#' discriminating branchpoint sites from non-branchpoint sites
#' (default = \code{0.52})
#' @param probabilityChange Minimum probability score change
#' required to call a branchpoint site as deleted or created by
#' a SNP (default = \code{0.15})
#' @return GRanges with summarised branchpoint changes
#' occuring within the intron due to a SNP.
#' @export
#' @import GenomicRanges
#' @importFrom stats aggregate
#' @examples
#' smallExons <- system.file("extdata","gencode.v26.annotation.small.gtf", package = "branchpointer")
#' exons <- gtfToExons(smallExons)
#' g <- BSgenome.Hsapiens.UCSC.hg38::BSgenome.Hsapiens.UCSC.hg38
#' 
#' querySNPFile <- system.file("extdata","SNP_example.txt", package = "branchpointer")
#' querySNP <- readQueryFile(querySNPFile,queryType = "SNP",exons = exons, filter = FALSE)
#' predictionsSNP <- predictBranchpoints(querySNP,queryType = "SNP",BSgenome = g)
#' 
#' summarySNP <- predictionsToSummary(querySNP,predictionsSNP)
#' @author Beth Signal
#'
predictionsToSummary <- function(query,
                                 predictions,
                                 probabilityCutoff = 0.52,
                                 probabilityChange = 0.15){
  
  mcols(query)$BP_num_REF = 0
  mcols(query)$BP_num_ALT = 0
  mcols(query)$deleted_n = 0
  mcols(query)$created_n = 0
  mcols(query)$dist_to_BP_REF = NA
  mcols(query)$dist_to_BP_ALT = NA
  mcols(query)$max_prob_REF = NA
  mcols(query)$max_prob_ALT = NA
  mcols(query)$max_U2_REF = NA
  mcols(query)$max_U2_ALT = NA
  
  predictions <- as.data.frame(mcols(predictions))

  # Reference sequence summary
  bps.ref <- which(predictions$branchpoint_prob >= probabilityCutoff & 
                     predictions$status == "REF")
  bps.ref <- predictions[bps.ref,]
  bps.ref$distance <- bps.ref$to_3prime - bps.ref$to_3prime_point
  
  tab <- as.data.frame(table(bps.ref$id))
  m <- match(query$id, tab$Var1)
  query$BP_num_REF[which(!is.na(m))] <- tab$Freq[m[which(!is.na(m))]]
  
  bps.ref[order(abs(bps.ref[,which(colnames(bps.ref) == "distance")])),]
  m <- match(query$id, bps.ref$id)
  query$dist_to_BP_REF[which(!is.na(m))] <- bps.ref$distance[m[which(!is.na(m))]]
  
  bps.ref.all <- predictions[which(predictions$status == "REF"),]
  bps.ref.all <- bps.ref.all[rev(order(bps.ref.all[,which(colnames(bps.ref.all) == "branchpoint_prob")])),]
  
  m <- match(query$id, bps.ref.all$id)
  query$max_prob_REF[which(!is.na(m))] <- bps.ref.all$branchpoint_prob[m[which(!is.na(m))]]
  
  bps.ref <- bps.ref[rev(order(bps.ref[,which(colnames(bps.ref) == "U2_binding_energy")])),]
  
  m <- match(query$id, bps.ref$id)
  query$max_U2_REF[which(!is.na(m))] <- bps.ref$U2_binding_energy[m[which(!is.na(m))]]
  
  # Alternative sequence summary
  bps.alt <- which(predictions$branchpoint_prob >= probabilityCutoff 
                   & predictions$status == "ALT")
  bps.alt <- predictions[bps.alt,]
  bps.alt$distance <- bps.alt$to_3prime - bps.alt$to_3prime_point
  
  tab <- as.data.frame(table(bps.alt$id))
  m <- match(query$id, tab$Var1)
  query$BP_num_ALT[which(!is.na(m))] <- tab$Freq[m[which(!is.na(m))]]
  
  bps.alt <- bps.alt[order(abs(bps.alt[,which(colnames(bps.alt) == "distance")])),]
  
  m <- match(query$id, bps.alt$id)
  query$dist_to_BP_ALT[which(!is.na(m))] <- bps.alt$distance[m[which(!is.na(m))]]
  
  bps.alt.all <- predictions[which(predictions$status == "ALT"),]
  bps.alt.all <- bps.alt.all[rev(order(bps.alt.all[,which(colnames(bps.alt.all) == "branchpoint_prob")])),]
  
  m <- match(query$id, bps.alt.all$id)
  query$max_prob_ALT[which(!is.na(m))] <- bps.alt.all$branchpoint_prob[m[which(!is.na(m))]]
  
  bps.alt <- bps.alt[rev(order(bps.alt[,which(colnames(bps.alt) == "U2_binding_energy")])),]
  
  m <- match(query$id, bps.alt$id)
  query$max_U2_ALT[which(!is.na(m))] <- bps.alt$U2_binding_energy[m[which(!is.na(m))]]
  
  id.loc <- with(predictions, paste0(id,"_", to_3prime_point))
  index <- which(id.loc %in% id.loc[predictions$branchpoint_prob > probabilityCutoff])
  
  # Any sites changed?
  bps.all <- predictions[index,]
  bps.all <- bps.all[,c('id','to_3prime_point','branchpoint_prob','status')]
  
  bps.all$id_site <- paste0(bps.all$id,"_",bps.all$to_3prime_point)
  bps.ref <- bps.all[bps.all$status=="REF",]
  bps.alt <- bps.all[bps.all$status=="ALT",]
  
  
  bps.ref$change.bySite <- (bps.ref$branchpoint_prob - 
    bps.alt$branchpoint_prob[match(bps.alt$id_site, bps.ref$id_site)])
  
  deleted <- as.data.frame(table(bps.ref$id[
    which(bps.ref$change.bySite > probabilityChange)]))
  created <- as.data.frame(table(bps.ref$id[
    which(bps.ref$change.bySite < (probabilityChange*-1))]))
  
  m <- match(query$id, deleted$Var1)
  query$deleted_n[which(!is.na(m))] <- deleted$Freq[m[which(!is.na(m))]]
  m <- match(query$id, created$Var1)
  query$created_n[which(!is.na(m))] <- created$Freq[m[which(!is.na(m))]]
  
  return(query) 
}

#' Make branchpoint window regions
#'
#' Generate branchpoint window regions corresponding to annotated exon(s) within a
#' queried gene, transcript or exon id
#' @param id identifier(s) for the query gene/transcript/exon id
#' @param idType type of id to match in the exon annotation file (\code{"gene_id"},
#' \code{"transcript_id"}, or \code{"exon_id"})
#' @param exons GRanges containing exon co-ordinates.
#' @param forceClosestExon Force branchpointer to find the closest exon and not the
#' exon annotated as 5' to the query
#' @return Granges with formatted query
#' @export
#' @import GenomicRanges
#' @examples
#' smallExons <- system.file("extdata","gencode.v26.annotation.small.gtf",package = "branchpointer")
#' exons <- gtfToExons(smallExons)
#' windowquery <- makeBranchpointWindowForExons("ENSG00000139618.14", "gene_id", exons)
#' windowquery <- makeBranchpointWindowForExons("ENST00000357654.7", "transcript_id", exons)
#' windowquery <- makeBranchpointWindowForExons("ENSE00003518965.1", "exon_id", exons)
#' @author Beth Signal

makeBranchpointWindowForExons <- function(id, idType, exons, forceClosestExon = FALSE) {
    
  validTypes <- c("gene_id", "transcript_id","exon_id")

  #missing or invalid types
  noType <- missing(idType)

  if(!noType){
    noType <-  noType | !(idType %in% validTypes)
  }


  if (!noType) {
    x <- which(colnames(mcols(exons)) == idType)
    y <- which(!is.na(match(mcols(exons)[,x], id)))
    #y <- grep(id[1], mcols(exons)[,x])
  }else{
    y <- NA
  }

  #go through possible columns if no matches found
  if (all(is.na(y)) | noType) {
    idType <- validTypes[1]
    x <- which(colnames(mcols(exons)) == idType)
    y <- which(!is.na(match(mcols(exons)[,x], id)))
    #y <- grep(id[1], mcols(exons)[,x])

    if (length(y) == 0) {
      idType <- validTypes[2]
      x <- which(colnames(mcols(exons)) == idType)
      y <- which(!is.na(match(mcols(exons)[,x], id)))
      #y <- grep(id[1], mcols(exons)[,x])
    }

    if (length(y) == 0) {
      idType <- validTypes[3]
      x <- which(colnames(mcols(exons)) == idType)
      y <- which(!is.na(match(mcols(exons)[,x], id)))
      #y <- grep(id[1], mcols(exons)[,x])
    }

    if (length(y) == 0) {
      stop(paste0("cannot find ", id[1]," in the exon annotation"))
    }

  }

  #use a subset of the exon annotation for faster processing
  
  gene_id <- unique(mcols(exons)$gene_id[y])
  subsetInd <- which(mcols(exons)$gene_id %in% gene_id)
  exons.subset <- exons[subsetInd]
  
  keep <- which(mcols(exons[y])$exon_number > 1)
  window <- exons[y][keep]
  
  # manually generate windows

  # make window starts & ends
  window.ends <- start(window) - 18
  window.starts <- window.ends - 26
    
  negStrandIndex <- which(as.logical(strand(window) == "-"))
    
  window.starts[negStrandIndex] <- 
    end(window)[negStrandIndex] + 18
  window.ends[negStrandIndex] <- 
    window.starts[negStrandIndex] + 26
    
  window.IRanges <- IRanges(start=window.starts, end=window.ends)
  # replace ranges
  ranges(window) <- window.IRanges
    
  # skips getQueryLoc() -- which can be time limiting step
  if(forceClosestExon == FALSE){
    
    # to_3prime will be 18 for all windows
    mcols(window)$to_3prime <- 18
    
    # get 5' exon
    # Note that this is not neccesarily the 'closest' exon
    # closest can be enforced with forceClosestExon = TRUE
    transcriptExonNum.5prime <- paste0(mcols(window)$transcript_id,"_",
                                       as.numeric(mcols(window)$exon_number) -1)
    transcriptExonNum <- paste0(mcols(exons.subset)$transcript_id,"_",
                                as.numeric(mcols(exons.subset)$exon_number))
    
    m <- match(transcriptExonNum.5prime, transcriptExonNum)
    to_5prime <- end(window) - end(exons.subset[m])
    to_5prime[negStrandIndex] <- 
      (start(exons.subset[m]) - start(window))[negStrandIndex]
    mcols(window)$to_5prime <- to_5prime
    mcols(window)$same_gene <- TRUE
    mcols(window)$exon_3prime <- mcols(window)$exon_id
    mcols(window)$exon_5prime <- mcols(exons.subset[m])$exon_id
    
  }else{
      window <- getQueryLoc(window,queryType = "region",exons = exons.subset)
  }
    
  mcols(window)$id <- mcols(window)$exon_id
  
  windowNames <- paste0(seqnames(window), "_", 
                        start(window),"_", 
                        end(window), "_", 
                        strand(window))
  rm <- which(duplicated(windowNames))
  if(length(rm) > 0){
    window <- window[-rm]
  }

  if(length(window) > 0){
    return(window)
  }

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/predictBranchpoints.R
\name{getPPT}
\alias{getPPT}
\title{Get the best polypyramidine tract}
\usage{
getPPT(attributes)
}
\arguments{
\item{attributes}{query attributes GenomicRanges}
}
\value{
distance to the start of the longest PPT, and its length
}
\description{
Takes a query genomic sequence, finds all potential polypyramidine tracts (PPTs)
between the test site and the annotated 3'exon.
Returns the distance to the start of the longest PPT, and its length.
}
\author{
Beth Signal
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readQueryFile.R
\name{getExonDists}
\alias{getExonDists}
\title{Get the closest 3' and 5' exons}
\usage{
getExonDists(query, exons, queryType)
}
\arguments{
\item{query}{GenomicRangesquery}

\item{exons}{GenomicRanges containing exon co-ordinates.
Should be produced by gtfToExons()}

\item{queryType}{type of query. "SNP" or "region"}
}
\value{
GenomicRanges with distance to the closest 3' and 5' exons,
whether these exons are part of the same gene (i.e is the location intronic),
and the identifiers for the 3' and 5' exons.
}
\description{
Finds the closest annotated exons from a genomic co-ordinate.
Returns the distance to the 3' exon, distance to the 5' exon,
ids of the 3' and 5' exon,
and if the exons are from the same parent gene
}
\author{
Beth Signal
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotBranchpointWindow.R
\name{plotBranchpointWindow}
\alias{plotBranchpointWindow}
\title{Plots branchpointer predictions}
\usage{
plotBranchpointWindow(queryName, predictions, probabilityCutoff = 0.52,
  plotMutated = FALSE, plotStructure = TRUE, exons)
}
\arguments{
\item{queryName}{query id used to identify the SNP or region}

\item{predictions}{Granges object generated by predictBranchpoints()}

\item{probabilityCutoff}{probability score cutoff value for displaying U2 binding energy}

\item{plotMutated}{plot alternative sequence predicitons alongside reference sequence predictions}

\item{plotStructure}{plot structures for gene and 3' exon containing and skipping isoforms}

\item{exons}{Granges containing exon co-ordinates.
Should be produced by gtfToExons()}
}
\value{
ggplot2 plot with branchpoint features in the specified intronic region
}
\description{
Plots branchpointer predictions
}
\examples{
smallExons <- system.file("extdata","gencode.v26.annotation.small.gtf",
package = "branchpointer")
exons <- gtfToExons(smallExons)
g <- BSgenome.Hsapiens.UCSC.hg38::BSgenome.Hsapiens.UCSC.hg38

querySNPFile <- system.file("extdata","SNP_example.txt", package = "branchpointer")
querySNP <- readQueryFile(querySNPFile,queryType = "SNP",exons = exons, filter = FALSE)
predictionsSNP <- predictBranchpoints(querySNP,queryType = "SNP",BSgenome = g)
plotBranchpointWindow(querySNP$id[1], predictionsSNP,
plotMutated = TRUE, exons = exons)
}
\author{
Beth Signal
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makeBranchpointWindowForSNP.R
\name{makeBranchpointWindowForSNP}
\alias{makeBranchpointWindowForSNP}
\title{Makes a branchpointer formatted GRanges object from refsnp ids}
\usage{
makeBranchpointWindowForSNP(refSNP, mart.snp, exons, maxDist = 50,
  filter = TRUE)
}
\arguments{
\item{refSNP}{Vector of refsnp ids}

\item{mart.snp}{biomaRt mart object specifying the BioMart database and dataset to be used}

\item{exons}{GRanges containing exon co-ordinates.
Should be produced by gtfToExons()}

\item{maxDist}{maximum distance a SNP can be from an annotated 3' exon.}

\item{filter}{remove SNP queries prior to finding finding nearest exons?}
}
\value{
formatted SNP query GRanges
}
\description{
Searches Biomart for refsnp ids, and pulls genomic location and sequence identity information
Reformats alleles so each query has only one alternative allele
}
\examples{
smallExons <- system.file("extdata","gencode.v26.annotation.small.gtf",package = "branchpointer")
exons <- gtfToExons(smallExons)

mart.snp <- biomaRt::useMart("ENSEMBL_MART_SNP", dataset="hsapiens_snp", host="www.ensembl.org")
query <- makeBranchpointWindowForSNP("rs587776767", mart.snp, exons)
}
\author{
Beth Signal
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gtfToExons.R
\name{gtfToExons}
\alias{gtfToExons}
\title{Convert GTF file to exon location file}
\usage{
gtfToExons(gtf)
}
\arguments{
\item{gtf}{file containing the gtf annotation.}
}
\value{
exon annotation GRanges
}
\description{
Converts a GTF annotation to exon locations
}
\examples{
smallExons <- system.file("extdata","gencode.v26.annotation.small.gtf",
package = "branchpointer")
exons <- gtfToExons(smallExons)
}
\author{
Beth Signal
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotBranchpointWindow.R
\name{plotStructure}
\alias{plotStructure}
\title{Plots transcript structures}
\usage{
plotStructure(exonID, exons, keepTranscripts = "overlapping")
}
\arguments{
\item{exonID}{id of the exon to plot}

\item{exons}{Granges containing exon co-ordinates.}

\item{keepTranscripts}{which transcripts to plot (\code{"overlapping"} or \code{"withExon"})
\code{"overlapping"} will plot all transcripts overlapping the exon, 
whereas \code{"withExon"} will plot all transcripts containing the exon.}
}
\value{
ggplot2 plot transcript structures
}
\description{
Plots transcript structures
}
\author{
Beth Signal
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readQueryFile.R
\name{exonsToIntrons}
\alias{exonsToIntrons}
\title{Convert exon annotation GRanges to intron locations}
\usage{
exonsToIntrons(exons, maxDist = 50)
}
\arguments{
\item{exons}{GRanges containing exon co-ordinates.
Should be produced by gtfToExons()}

\item{maxDist}{Maximum distance from the 3' exon to create the branchpoint region.}
}
\value{
GRanges containing intron window co-ordinates
}
\description{
Converts exon annotation to intron locations overlapping the branchpoint region
for exculsion of non-branchpoint region SNPs
Returns a character vector of chromosome locations
}
\author{
Beth Signal
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/predictBranchpoints.R
\name{getCanonical3SS}
\alias{getCanonical3SS}
\title{Get locations of the first five AG 3' splice site motifs}
\usage{
getCanonical3SS(ag)
}
\arguments{
\item{ag}{Vector of distances to the AG splice site motif.}
}
\value{
Locations of the first five AG dinucleotides
}
\description{
Takes a variable length vector of distances to the AG motif,
sorts and returns the first five.
If there are less than five elements in the vector, returns the sorted vector
and fills the remainder of the values with 300.
}
\author{
Beth Signal
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/predictionsToSummary.R
\name{predictionsToSummary}
\alias{predictionsToSummary}
\title{Convert SNP branchpoint predictions across the branchpoint window to an intronic summary}
\usage{
predictionsToSummary(query, predictions, probabilityCutoff = 0.52,
  probabilityChange = 0.15)
}
\arguments{
\item{query}{query GRanges containing all SNP ids to be summarised}

\item{predictions}{site-wide branchpoint proability predictions
produced from predictBranchpoints()}

\item{probabilityCutoff}{Value to be used as the cutoff for
discriminating branchpoint sites from non-branchpoint sites
(default = \code{0.52})}

\item{probabilityChange}{Minimum probability score change
required to call a branchpoint site as deleted or created by
a SNP (default = \code{0.15})}
}
\value{
GRanges with summarised branchpoint changes
occuring within the intron due to a SNP.
}
\description{
Takes predictions of branchpoint probabilities from a reference
and alternative SNP and summarises the effect(s) of the SNP.
}
\examples{
smallExons <- system.file("extdata","gencode.v26.annotation.small.gtf", package = "branchpointer")
exons <- gtfToExons(smallExons)
g <- BSgenome.Hsapiens.UCSC.hg38::BSgenome.Hsapiens.UCSC.hg38

querySNPFile <- system.file("extdata","SNP_example.txt", package = "branchpointer")
querySNP <- readQueryFile(querySNPFile,queryType = "SNP",exons = exons, filter = FALSE)
predictionsSNP <- predictBranchpoints(querySNP,queryType = "SNP",BSgenome = g)

summarySNP <- predictionsToSummary(querySNP,predictionsSNP)
}
\author{
Beth Signal
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/predictBranchpoints.R
\name{predictBranchpoints}
\alias{predictBranchpoints}
\title{Predict branchpoint probability scores}
\usage{
predictBranchpoints(query, uniqueId = "test", queryType,
  workingDirectory = ".", genome = NA, bedtoolsLocation = NA,
  BSgenome = NULL, useParallel = FALSE, cores = 1, rmChr = FALSE)
}
\arguments{
\item{query}{branchpointer query GenomicRanges}

\item{uniqueId}{unique string identifier for intermediate .bed and .fa files.}

\item{queryType}{type of branchpointer query. "SNP" or "region".}

\item{workingDirectory}{directory where intermediate .bed and .fa are located}

\item{genome}{.fa genome file location}

\item{bedtoolsLocation}{bedtools binary location (which bedtools)}

\item{BSgenome}{BSgenome object}

\item{useParallel}{use parallelisation to speed up code?}

\item{cores}{number of cores to use in parallelisation (default = \code{1})}

\item{rmChr}{remove "chr" before chromosome names before writing bed file.
Required if genome sequence names do not contain "chr"}
}
\value{
GenomicRanges object with branchpoint probaility scores for each site in query
}
\description{
predicts branchpoint probability scores for each query site.
}
\examples{
smallExons <- system.file("extdata","gencode.v26.annotation.small.gtf",
package = "branchpointer")
exons <- gtfToExons(smallExons)
g <- BSgenome.Hsapiens.UCSC.hg38::BSgenome.Hsapiens.UCSC.hg38

querySNPFile <- system.file("extdata","SNP_example.txt", package = "branchpointer")
querySNP <- readQueryFile(querySNPFile,queryType = "SNP",exons = exons, filter = FALSE)
predictionsSNP <- predictBranchpoints(querySNP,queryType = "SNP",BSgenome = g)
}
\author{
Beth Signal
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makeBranchpointWindowForExons.R
\name{makeBranchpointWindowForExons}
\alias{makeBranchpointWindowForExons}
\title{Make branchpoint window regions}
\usage{
makeBranchpointWindowForExons(id, idType, exons, forceClosestExon = FALSE)
}
\arguments{
\item{id}{identifier(s) for the query gene/transcript/exon id}

\item{idType}{type of id to match in the exon annotation file (\code{"gene_id"},
\code{"transcript_id"}, or \code{"exon_id"})}

\item{exons}{GRanges containing exon co-ordinates.}

\item{forceClosestExon}{Force branchpointer to find the closest exon and not the
exon annotated as 5' to the query}
}
\value{
Granges with formatted query
}
\description{
Generate branchpoint window regions corresponding to annotated exon(s) within a
queried gene, transcript or exon id
}
\examples{
smallExons <- system.file("extdata","gencode.v26.annotation.small.gtf",package = "branchpointer")
exons <- gtfToExons(smallExons)
windowquery <- makeBranchpointWindowForExons("ENSG00000139618.14", "gene_id", exons)
windowquery <- makeBranchpointWindowForExons("ENST00000357654.7", "transcript_id", exons)
windowquery <- makeBranchpointWindowForExons("ENSE00003518965.1", "exon_id", exons)
}
\author{
Beth Signal
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readQueryFile.R
\name{readQueryFile}
\alias{readQueryFile}
\title{Read a query file}
\usage{
readQueryFile(queryFile, queryType, exons, maxDist = 50, filter = TRUE)
}
\arguments{
\item{queryFile}{tab delimited file containing query information.
For intronic regions should be in the format: region id, chromosome name, region start, region end, strand.
For SNP variants should be in the format: SNP id, chromosome name, SNP position, strand, reference allele (A/T/C/G), alternative allele (A/T/C/G)}

\item{queryType}{type of query file (\code{"SNP"} or \code{"region"})}

\item{exons}{GRanges containing exon co-ordinates.
Should be produced by gtfToExons()}

\item{maxDist}{maximum distance a SNP can be from an annotated 3' exon.}

\item{filter}{remove SNP queries prior to finding finding nearest exons.}
}
\value{
Formatted query GRanges
}
\description{
Reads and formats a manually generated query file, and finds realtive locations of the closest annotated exons
Converts unstranded SNPs to two entries for each strand.
Checks for duplicate names and replaces if found.
}
\examples{
smallExons <- system.file("extdata","gencode.v26.annotation.small.gtf", package = "branchpointer")
exons <- gtfToExons(smallExons)

querySNPFile <- system.file("extdata","SNP_example.txt", package = "branchpointer")
querySNP <- readQueryFile(querySNPFile, queryType = "SNP", exons)

queryIntronFile <- system.file("extdata","intron_example.txt", package = "branchpointer")
queryIntron <- readQueryFile(queryIntronFile,queryType = "region", exons)
}
\author{
Beth Signal
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/predictBranchpoints.R
\name{getBranchpointSequence}
\alias{getBranchpointSequence}
\title{Get branchpoint sequence features
Gets intronic sequence covering the branchpoint window and extracts predictive features}
\usage{
getBranchpointSequence(query, uniqueId = "test", queryType,
  workingDirectory = ".", genome = NA, bedtoolsLocation = NA,
  BSgenome = NULL, useParallel = FALSE, cores = 1, rmChr = FALSE)
}
\arguments{
\item{query}{branchpointer query GenomicRanges}

\item{uniqueId}{unique string identifier for intermediate .bed and .fa files.}

\item{queryType}{type of branchpointer query. "SNP" or "region".}

\item{workingDirectory}{directory where intermediate .bed and .fa are located}

\item{genome}{.fa genome file location}

\item{bedtoolsLocation}{bedtools binary location (which bedtools)}

\item{BSgenome}{BSgenome object}

\item{useParallel}{use parallelisation to speed up code?}

\item{cores}{number of cores to use in parallelisation (default = \code{1})}

\item{rmChr}{remove "chr" before chromosome names before writing bed file.
Required if genome sequence names do not contain "chr"}
}
\value{
GenomicRanges with all features required to predict branchpoint probability scores
}
\description{
Get branchpoint sequence features
Gets intronic sequence covering the branchpoint window and extracts predictive features
}
\author{
Beth Signal
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readQueryFile.R
\name{getQueryLoc}
\alias{getQueryLoc}
\title{Find the closest 3' and 5' exons to a branchpointer query}
\usage{
getQueryLoc(query, queryType, maxDist = 50, filter = TRUE, exons)
}
\arguments{
\item{query}{branchpointer query GenomicRanges
must have chromosome at position 2, genomic co-ordinate at position 3,
and strand at position 4.}

\item{queryType}{type of query file (\code{"SNP"} or \code{"region"})}

\item{maxDist}{maximum distance a SNP can be from an annotated 3' exon.}

\item{filter}{remove SNP queries prior to finding finding nearest exons.}

\item{exons}{data.frame containing exon co-ordinates.
Should be produced by gtfToExons()}
}
\value{
GenomicRanges with the query and its location relative to the 3' and 5' exons
}
\description{
Finds the closest annotated exons from genomic co-ordinates in a branchpointer query GRanges
}
\author{
Beth Signal
}
\keyword{internal}
